/**
 * CFilterSelect - 筛选项目，单项选择
 * @author Tevin
 */

<template>
    <view
        class="c-filter-select"
        :class="'type-'+type"
    >
        <view
            class="label"
            v-if="type==='item'"
        >{{label}}</view>
        <picker
            mode="selector"
            range-key="name"
            :range="options2"
            @change="evt=>handleChange(evt.detail.value)"
        >
            <view class="content">
                <view
                    class="label"
                    v-if="type==='bar'"
                >
                    {{label}}：
                </view>
                <view :class="selected ? 'value':'empty'">
                    {{selected ? options2[selectIndex].name : ('请选择' + label)}}
                </view>
                <view class='at-icon at-icon-chevron-down' />
            </view>
        </picker>
    </view>
</template>

<script>
import Taro from '@tarojs/taro';

export default {
    name: 'CFilterSelect',
    props: {
        type: String,
        label: String,
        options: Array,
        onChange: Function,
    },
    data() {
        return {
            selectIndex: 0,
            selected: false,
        };
    },
    computed: {
        options2() {
            return [{ name: '- 取消选择 -' }, ...this.options];
        },
    },
    methods: {
        handleChange(index) {
            this.selectIndex = Number(index);
            if (this.selectIndex > 0) {
                this.selected = true;
                this.onChange(this.options2[this.selectIndex].value);
            } else {
                this.selected = false;
                this.onChange();
            }
        },
    },
};
</script>